diff --git a/bin/cdist-explorer-coordinator b/bin/cdist-explorer-coordinator
new file mode 100755
index 00000000..8556dbd9
--- /dev/null
+++ b/bin/cdist-explorer-coordinator
@@ -0,0 +1,36 @@
+#!/bin/sh
+#
+# 2010-2011 Nico Schottelius (nico-cdist at schottelius.org)
+#
+# This file is part of cdist.
+#
+# cdist is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# cdist is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with cdist. If not, see .
+#
+#
+# Coordinate run of explorers on target (this script runs on the target)
+#
+
+. cdist-config
+
+[ $# -eq 2 ] || __cdist_usage " "
+
+set -e
+
+explorer_dir="$1"; shift
+result_dir="$1"; shift
+
+cd "${explorer_dir}"
+for explorer in *; do
+ "./$explorer" > "${result_dir}/${explorer}"
+done
diff --git a/bin/cdist-explorer-run b/bin/cdist-explorer-run
index 2329c9c7..494c8c42 100755
--- a/bin/cdist-explorer-run
+++ b/bin/cdist-explorer-run
@@ -46,12 +46,6 @@ ssh "${__cdist_remote_user}@${__cdist_target_host}" \
# Copy explorers to remote source directory
# FIXME: enable -q as soon as the code is cleaned up
-
-cd "${explorer_dir}"
-for explorer in *; do
- "./$explorer" > "${result_dir}/${explorer}"
-done
-
scp "${__cdist_src_dir}"/* \
"${__cdist_remote_user}@${__cdist_target_host}:${__cdist_remote_src_dir}"